package com.example.workflow;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.time.LocalDateTime;

@SpringBootApplication
@EnableScheduling
public class Application {

  @Autowired
  private EmailConfig emailConfig;

  public static void main(String... args) {
    SpringApplication.run(Application.class, args);
  }

  @Scheduled(cron = "0 * * * * *",zone = "Europe/London")
  public void function (){
    String host = "imap.gmail.com";
    String mailStoreType = "imap";
    String username = emailConfig.getEmailAddress();
    String password = emailConfig.getEmailPassword();

    com.example.workflow.EmailService mailservice = new com.example.workflow.EmailService();

    System.out.println("Current Time:" + LocalDateTime.now());
  }
}