package com.example.workflow;

import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import javax.inject.Named;

@Named
public class AutoFill implements JavaDelegate {

    private final JdbcTemplate jdbcTemplate;

    public AutoFill(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    @Override
    public void execute(DelegateExecution execution) throws Exception {
        boolean userExists = (Boolean) execution.getVariable("checkUser");
        String email = (String) execution.getVariable("EmailAddress");

        if (userExists) {
            String username = getUsername(email);

            execution.setVariable("userName", username);
        }
    }

    private String getUsername(String email) {

        String query = "SELECT name FROM users WHERE email = ?";
        try {
            String username = jdbcTemplate.queryForObject(query, new Object[]{email}, String.class);
            return username;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
