package com.example.workflow;

import org.camunda.bpm.engine.delegate.BpmnError;
import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;

import javax.inject.Named;

@Named
public class CombineIssueInfo implements JavaDelegate {

    @Override
    public void execute(DelegateExecution delegateExecution) throws Exception {

        //Gets textfield keys (gets the user input) and stores as variables
        String issueDescription = (String) delegateExecution.getVariable("issueDescription");
        String additionalInfo = (String) delegateExecution.getVariable("additionalInfo");

        //
        if (issueDescription == null) {
            issueDescription = "Unknown";
        }
        if (additionalInfo == null) {
            additionalInfo = "Unknown";
        }

        //This should put the description that lacked information and the request additional info together.
        //This can also further add info if sufficient info is requested more than once.
        issueDescription =  issueDescription + " [ADDITIONAL INFO] " + additionalInfo;


        delegateExecution.setVariable("issueDescription", issueDescription);
    }
}