package com.example.workflow;

import jakarta.inject.Named;
import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;
import org.springframework.jdbc.core.JdbcTemplate;

@Named
public class InsertTicketDataDelegate implements JavaDelegate {

    private final JdbcTemplate jdbcTemplate;

    public InsertTicketDataDelegate(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    @Override
    public void execute(DelegateExecution execution) throws Exception {
        String username = (String) execution.getVariable("userName");
        String email = (String) execution.getVariable("EmailAddress");
        String issueTopic = (String) execution.getVariable("issueTopic");
        String issueDescription = (String) execution.getVariable("issueDescription");
        String effect = (String) execution.getVariable("effect");
        String priority = (String) execution.getVariable("priority");
        String estimatedTime = (String) execution.getVariable("estimatedTime");

        String sql = "INSERT INTO ticket_submission (username, email, issue_topic, issue_description, effect, priority, estimatedTime, status) VALUES (?, ?, ?, ?, ?, ?, ?, ?)";

        int rowsAffected = jdbcTemplate.update(sql, username, email, issueTopic, issueDescription, effect, priority, estimatedTime, "Open");

        if (rowsAffected > 0) {
            execution.setVariable("ticketSaved", true);
        } else {
            execution.setVariable("ticketSaved", false);
        }
    }
}
