package com.example.workflow;

import jakarta.inject.Named;
import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;
import org.springframework.jdbc.core.JdbcTemplate;

@Named
public class SurveyDataDelegate implements JavaDelegate {

    private JdbcTemplate jdbcTemplate;

    public SurveyDataDelegate(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    @Override
    public void execute(DelegateExecution execution) throws Exception {
        try {

            // Retrieve survey answers from form keys and converts them into variables
            String staffSolutionSatisfaction = (String) execution.getVariable("staff_Opinion");
            String timingSatisfaction = (String) execution.getVariable("Timing");
            String improvementIdea = (String) execution.getVariable("ideaSolution");

            //Will populate already existing table called survey_data that I created in h2-console using a schema script
            String sql = "INSERT INTO survey_data (staff_Satisfied, timing_Satisfied, idea_Solution) VALUES (?, ?, ?)";
            jdbcTemplate.update(sql, staffSolutionSatisfaction, timingSatisfaction, improvementIdea);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}